<link rel="import" href="../polymer/polymer-element.html">

<link rel="import" href="../iron-collapse/iron-collapse.html">

<link rel="import" href="../paper-button/paper-button.html">
<link rel="import" href="../paper-icon-button/paper-icon-button.html">
<link rel="import" href="../paper-input/paper-input.html">
<link rel="import" href="../paper-input/paper-textarea.html">

<link rel="import" href="../polymerfire/firebase-app.html">
<link rel="import" href="../polymerfire/firebase-auth.html">
<link rel="import" href="../polymerfire/firebase-document.html">
<link rel="import" href="../polymerfire/firebase-query.html">
<link rel="import" href="./util/sound-mixin.html">

<link rel="import" href="/util/test-new.html"> 
<link rel="import" href="/util/chat-message.html"> 
<link rel="import" href="/util/chat-pending.html"> 

<dom-module id="simple-chat">
  <template>
    <style>
      :host { display: block; max-width: 300px; }
      .container-chat { max-height: 300px; overflow-y: auto; font-size: .75rem; }
      .head-chat { 
        border-radius: 20px 20px 0px 0px;
        -moz-border-radius: 20px 20px 0px 0px;
        -webkit-border-radius: 20px 20px 0px 0px;
        border: 2px solid #d1d1d1;
        text-align: center;
        background-color: #e22e2e;
        color: #f1f1f1
      }
      .head-chat > h3 { margin: 0px; padding: .5rem; }
      .wrapper-chat { border: 2px solid #d1d1d1; padding: .5rem 0rem .25rem 0rem; background-color: #fff; }
      .grid { display: grid; grid-template-columns: 1fr 2rem; padding: 0rem .25rem; }
      .section-form { padding: 2rem; }
    </style>

    <test-new></test-new>
    <!-- DEV -->
    <firebase-app 
      app="{{fbapp}}" 
      api-key="AIzaSyBXaAelYDIxIiPNz8tzByY_l7NlTim-WVo" 
      auth-domain="ferreteria-6c215.firebaseapp.com" 
      database-url="https://ferreteria-6c215.firebaseio.com"
      project-id="ferreteria-6c215"
      storage-bucket="ferreteria-6c215.appspot.com" 
      messaging-sender-id="652754626304"></firebase-app>

    <!-- PRD -->
    <!-- <firebase-app 
      app="{{fbapp}}" 
      api-key="AIzaSyBINhuqkFFjUX-Cozy87bS-v-5oW1w9aOQ" 
      auth-domain="ferretornillos-b32d7.firebaseapp.com" 
      database-url="https://ferretornillos-b32d7.firebaseio.com"
      project-id="ferretornillos-b32d7"
      storage-bucket="ferretornillos-b32d7.appspot.com" 
      messaging-sender-id="884905693468"></firebase-app> -->

    <template is="dom-if" if="[[!isAdmon]]">
      <firebase-query
        path="chat/conversaciones/[[userSession.uid]]/messages"
        order-by-child="date"
        data="{{messages}}"></firebase-query>
    </template>
    <template is="dom-if" if="[[isAdmon]]">
      <firebase-query
        path="chat/conversaciones"
        order-by-child="status"
        equal-to="open"
        data="{{conversation}}"></firebase-query>
      <template is="dom-if" if="[[conversation]]">
        <firebase-query
          path="chat/conversaciones/[[conversation.0.$key]]/messages"
          order-by-child="date"
          data="{{messagesAdmon}}"></firebase-query>
      </template>
    </template>
    <firebase-document path="chat/configuracion/disponible" data="{{chatEnable}}"></firebase-document>
    <firebase-document id="fbDoc"></firebase-document>

    <div class="head-chat grid" on-click="_toggle">
      <template is="dom-if" if="[[isAdmon]]">
        <template is="dom-if" if="[[!idChat]]">
          <h3 style="display: inline-flex;">Chat - Ferretornillos</h3>
        </template>
        <template is="dom-if" if="[[idChat]]">
          <b>
            <p style="display: inline-flex;">[[conversation.0.name]]</p>
            <p style="display: inline-flex;">[[conversation.0.email]]</p>
          </b> 
        </template>
      </template>
      <template is="dom-if" if="[[!isAdmon]]">
        <h3 style="display: inline-flex;">Chat - Ferretornillos</h3>
      </template>
      <template is="dom-if" if="[[hasSession]]">
        <paper-icon-button on-click="_endChat" icon="icons:close"></paper-icon-button>
      </template>
    </div>

    <iron-collapse id="collapse">
      <div class="wrapper-chat">
        <template is="dom-if" if="[[chatEnable]]">
          <template is="dom-if" if="[[!hasSession]]">
            <div class="section-form">
              <paper-input type="text" id="name" label="Nombre" auto-validate 
                error-message="Escribe tu nombre" required></paper-input>
              <paper-input type="email" id="email" label="Correo-e" auto-validate 
                error-message="Escribe un correo valido" required></paper-input>
              <br/>
              <paper-button raised on-click="_initChat">Iniciar</paper-button>
            </div>
          </template>
          <template is="dom-if" if="[[hasSession]]">
            <div id="container-chat" class="container-chat">
              <template is="dom-if" if="[[idChat]]">
                <template is="dom-if" if="[[isAdmon]]">
                  <chat-message messages="[[messagesAdmon]]"></chat-message>
                </template>
                <template is="dom-if" if="[[!isAdmon]]">
                  <chat-message messages="[[messages]]"></chat-message>
                </template>
              </template>
              <template is="dom-if" if="[[!idChat]]">
                <template is="dom-if" if="[[!isAdmon]]">
                  <chat-pending messages="[[messages]]"></chat-pending>
                </template>
              </template>
            </div>
            <div class="grid">
              <div>
                <paper-textarea id="message" label="Escribe algo" no-label-float></paper-textarea>
              </div>
              <div>
                <paper-icon-button on-click="_sendMessage" icon="icons:send"></paper-icon-button>
              </div>
            </div>
          </template>              
        </template>

        <template is="dom-if" if="[[!chatEnable]]">
          <div style="padding: .5rem;">
            <h3>Nuestros horarios de atención vía Chat son:</h3>
            <p>Lunes a viernes de 08:00 a 18:00 horas</p>
            <p>Sábados de 08:00 a 14:00 horas</p>
          </div>
        </template>
      </div>
    </iron-collapse>

  </template>

  <script>
    class SimpleChat extends SoundMixin(Polymer.Element) {
    //class SimpleChat extends Polymer.Element {
      static get is() { return 'simple-chat'; }
      static get properties() {
        return {
          fbapp: Object,
          conversation: { type: Object, observer: '_obsConversacion' },
          hasSession: { type: Boolean, value: false },
          idChat: String,
          isAdmon: { type: Boolean, value: false, observer: '_obsIsAdmon' },
          messages: Array,
          messagesAdmon: Array,
          userSession: Object
        };
      }

      static get observers() { 
        return [ '_obsMessages(messagesAdmon.*)', '_obsMessages(messages.*)' ] 
      }

      ready() {
        super.ready();
        this.fire('evento-uno', { value: 'ok'});
      }

      _endChat() {
        this.$.fbDoc.reset();
        this.fbapp.database().ref('chat/conversaciones/')
        .child(this.idChat).child('status').set('close');
        this.idChat = '';
        this.hasSession = false;
      }

      _initChat() {
        if(this.shadowRoot.querySelector('#name').validate() 
          && this.shadowRoot.querySelector('#email').validate()
            && this.messages.length == 0) {
            const d = new Date();
            let dataChat = { 
              date: d.getTime(), 
              name: this.shadowRoot.querySelector('#name').value, 
              email: this.shadowRoot.querySelector('#email').value,
              status: 'pending'
            };
            let ref = this.fbapp.database().ref('chat/conversaciones/');
            this.idChat = ref.push().key;
            ref.child(this.idChat).set(dataChat);
            this.hasSession = true;
        }
      }
      
      _obsConversacion() {
        if(this.conversation[0] != undefined) { this.idChat = this.conversation[0].$key; }
      }

      _obsIsAdmon() { this.hasSession = (this.isAdmon) ? true : false; }

      _obsMessages() {
        if(this.messagesAdmon != undefined && this.messagesAdmon.length) {
          let that = this;
          setTimeout(function(){ 
            that.shadowRoot.querySelector('#container-chat').scrollTop = that.shadowRoot.querySelector('#container-chat').scrollHeight + 150; 
          }, 100);
        }
      }

      _sendMessage() {
        const d = new Date();
        let isAdmon = (this.isAdmon) ? true : false;
        let menssage = {
          date: d.getTime(),
          isAdmon: isAdmon,
          message: this.shadowRoot.querySelector('#message').value
        }
        this.$.fbDoc.reset();
        this.$.fbDoc.data = menssage;
        this.$.fbDoc.saveValue('chat/conversaciones/' + this.idChat + '/messages')
        this.shadowRoot.querySelector('#message').value = '';
        this.shadowRoot.querySelector('#message').focus();
      }

      _toggle() { this.$.collapse.toggle(); }

    }

    window.customElements.define(SimpleChat.is, SimpleChat);
  </script>
</dom-module>
